<template>
  <b-row
    class="versions-viewer"
    no-gutters
  >
    <b-col
      class="editor-container"
      :sm="isAdminView && showSidebar ? '9' : null"
      :lg="isAdminView && showSidebar ? '10' : null"
    >
      <b-form @submit.prevent="submitFilterVersion">
        <b-form-file
          ref="fileBrowse"
          hidden
          plain
          @input="uploadFilterVersion"
        />
        <base-editor
          v-model="localFilterVersion.code"
          :filename="filter.name + '.py'"
          :read-only="!editing"
        >
          <template
            v-if="selectedVersion"
            #header
          >
            <section class="version-info">
              <b-row align-v="baseline">
                <b-col cols="auto">
                  <h2>Version #{{ selectedVersion.id }}</h2>
                </b-col>
                <b-col class="d-flex align-items-center">
                  <status-badge :status="selectedVersion.status" />
                  <span
                    v-if="selectedVersion.transitioned_at || selectedVersion.feedback"
                    id="selected-version-tooltip"
                    class="pl-2 text-secondary"
                  >
                    <font-awesome-icon icon="info-circle" />
                  </span>
                  <b-tooltip
                    placement="right"
                    target="selected-version-tooltip"
                    variant="primary"
                  >
                    <p
                      v-if="selectedVersion.transitioned_at"
                      class="text-left"
                    >
                      Filter version transitioned to {{ selectedVersion.status.replace('_', ' ') }}
                      on {{ formatISODate(selectedVersion.transitioned_at) }} (UTC)
                    </p>
                    <p
                      v-if="selectedVersion.feedback"
                      class="text-left"
                    >
                      Feedback provided by the ANTARES team:
                      <br>
                      {{ selectedVersion.feedback }}
                    </p>
                  </b-tooltip>
                </b-col>
                <b-col cols="12">
                  <p class="version-comment">
                    {{ selectedVersion.comment }}
                  </p>
                </b-col>
              </b-row>
            </section>
          </template>
          <template
            v-if="!isAdminView"
            #button-toolbar
          >
            <b-input-group
              v-if="!editing && filterVersions.length"
              class="mx-1"
            >
              <b-form-select
                v-model="selectedVersionId"
                :options="availableVersions"
              />
            </b-input-group>
          </template>
          <template
            v-if="isAdminView"
            #extra-button-toolbar
          >
            <div v-if="selectedVersion">
              <status-modal
                :filter-name="filter.name"
                :filter-version-id="selectedVersionId"
                :on-confirm="(payload) => transitionFilterVersionTo(targetStatus, payload)"
                :status="targetStatus"
                :visible.sync="statusModalVisible"
              />
              <b-button
                v-for="transition in statusTransitionsMetadata[selectedVersion.status]"
                :key="transition.to"
                :disabled="transitioning || editing || submitting"
                :variant="transition.variant"
                class="ml-1"
                @click="attemptTransitionTo(transition.to)"
              >
                <strong>{{ transition.event }}</strong>
              </b-button>
            </div>
            <b-button-group
              class="ml-1 d-none d-sm-block"
              size="md"
            >
              <b-button
                id="show-sidebar-btn"
                variant="light"
                @click="showSidebar = !showSidebar"
              >
                <font-awesome-icon
                  :icon="showSidebar ? 'indent' : 'outdent'"
                  class="text-secondary"
                />
              </b-button>
              <b-tooltip
                target="show-sidebar-btn"
                triggers="hover"
                variant="primary"
              >
                {{ showSidebar ? 'Hide versions list' : 'Show versions list' }}
              </b-tooltip>
            </b-button-group>
          </template>
          <template #body-pre-code>
            <b-progress
              v-if="loading"
              :max="100"
              :value="100"
              animated
              class="rounded-0"
              height="2em"
              striped
              variant="warning"
            />
            <b-alert
              v-model="showWarningMessage"
              dismissible
              variant="warning"
            >
              {{
                warningMessage
              }}
            </b-alert>
            <b-alert
              v-model="showErrorMessage"
              dismissible
              variant="danger"
            >
              {{
                errorMessage
              }}
            </b-alert>
          </template>
          <template #footer>
            <div
              v-if="editing"
              class="mb-2"
            >
              <b-form-textarea
                v-model="localFilterVersion.comment"
                :state="
                  $v.localFilterVersion.comment.$dirty
                    ? !$v.localFilterVersion.comment.$invalid
                    : null
                "
                placeholder="Enter a comment for this new filter version (up to 255 characters)."
                required
                size="sm"
                @blur="$v.localFilterVersion.$touch()"
              />
              <b-form-invalid-feedback v-if="!$v.localFilterVersion.comment.maxLength">
                Field may not have more than 255 characters.
              </b-form-invalid-feedback>
              <b-form-invalid-feedback v-if="!$v.localFilterVersion.comment.required">
                Field is required.
              </b-form-invalid-feedback>
            </div>
            <div class="float-right">
              <b-button
                :disabled="uploading"
                class="mx-2"
                variant="warning"
                @click="$refs.fileBrowse.$el.click()"
              >
                <font-awesome-icon
                  v-if="uploading"
                  icon="spinner"
                  disable
                  pulse
                />
                <font-awesome-icon
                  v-else
                  icon="upload"
                />
                Upload
              </b-button>
              <b-button
                v-if="!editing"
                :disabled="uploading"
                variant="success"
                @click="editFilterVersion"
              >
                <font-awesome-icon icon="pencil-alt" />
                Edit this version and submit
              </b-button>
              <b-button
                v-if="editing"
                :disabled="loading"
                class="mr-2"
                variant="danger"
                @click="cancelEditFilterVersion"
              >
                <font-awesome-icon icon="times" />
                Cancel
              </b-button>
              <b-button
                v-if="editing"
                :disabled="submitting || $v.localFilterVersion.$invalid"
                type="submit"
                variant="success"
              >
                <font-awesome-icon
                  v-if="submitting"
                  icon="spinner"
                  pulse
                />
                <font-awesome-icon
                  v-else
                  icon="check"
                />
                Submit
              </b-button>
            </div>
          </template>
        </base-editor>
      </b-form>
    </b-col>
    <b-col
      v-if="isAdminView"
      class="sidebar-container h-100"
      :class="{ visible: showSidebar }"
      sm="3"
      lg="2"
    >
      <versions-sidebar
        :disabled="editing || submitting"
        :enabled-version-id="filter.enabled_version && filter.enabled_version.id"
        :latest-version-id="latestVersion && latestVersion.id"
        :selected-version-id.sync="selectedVersionId"
        :versions="filterVersions"
      />
    </b-col>
  </b-row>
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue';
import { maxLength, required } from 'vuelidate/lib/validators';
import { FILTER_VERSION_STATUS, STATUS_METADATA, STATUS_TRANSITIONS } from '@/common/constants';
import { Filter, FilterVersion } from '@/common/types';
import { FilterService } from '@/api';
import { Error } from '@/api/client/middleware/error';
import BaseEditor from '@/components/BaseEditor.vue';
import StatusBadge from '@/components/Filter/StatusBadge.vue';
import StatusModal from '@/components/Filter/StatusModal.vue';
import VersionsSidebar from '@/components/Filter/VersionsSidebar.vue';

type FilterVersionEditableFields = Pick<FilterVersion, 'code' | 'comment'>;

interface FilterVersionSelectOption {
  label: string;
  options: {
    value: string;
    text: string;
  }[];
  value: string;
  text: string;
}

function truncate(string: string, length: number): string {
  return string.length > length ? `${string.substr(0, length - 1)}...` : string;
}

const TEMPLATE_FIRST_FILTER_VERSION: FilterVersionEditableFields = {
  code: '"""\nPlease paste or upload your filter code here.\n"""',
  comment: '',
};

export default Vue.extend({
  components: {
    BaseEditor,
    StatusBadge,
    StatusModal,
    VersionsSidebar,
  },

  props: {
    filter: {
      type: Object,
      required: true,
    } as PropOptions<Filter>,
  },

  data() {
    return {
      editing: false,
      errorMessage: '',
      filterVersions: [] as FilterVersion[],
      loading: true,
      localFilterVersion: {
        code: '',
        comment: '',
      } as FilterVersionEditableFields,
      selectedVersionId: null as string | null,
      showErrorMessage: false,
      showSidebar: true,
      showWarningMessage: false,
      statusModalVisible: false,
      submitting: false,
      targetStatus: '',
      transitioning: false,
      uploading: false,
      warningMessage: '',
    };
  },

  validations: {
    localFilterVersion: {
      code: {
        required,
      },
      comment: {
        required,
        maxLength: maxLength(255),
      },
    },
  },

  computed: {
    availableVersions(): Partial<FilterVersionSelectOption>[] {
      const availableVersions: Partial<FilterVersionSelectOption>[] = [];
      if (this.filter.enabled_version) {
        availableVersions.push({
          value: this.filter.enabled_version.id,
          text: 'Enabled Version',
        });
      }
      if (this.latestVersion) {
        availableVersions.push({
          value: this.latestVersion.id,
          text: 'Latest Version',
        });
      }
      availableVersions.push({
        label: 'Filters by Date',
        options: this.filterVersions.map((version: FilterVersion) => ({
          value: version.id,
          text: `${version.created_at.substring(0, 10)} ${
            version.comment ? truncate(version.comment, 30) : ''
          }`,
        })),
      });
      return availableVersions;
    },

    isAdminView(): boolean {
      return this.$route.meta?.requireAdmin;
    },

    selectedVersion(): FilterVersion | null {
      const index = this.filterVersions.findIndex(
        (filterVersion: FilterVersion) => filterVersion.id === this.selectedVersionId,
      );
      if (index !== -1) {
        return this.filterVersions[index];
      }
      return null;
    },

    latestVersion(): FilterVersion | null {
      if (!this.filterVersions.length) {
        return null;
      }
      return this.filterVersions[this.filterVersions.length - 1];
    },

    statusTransitionsMetadata() {
      return Object.entries(STATUS_TRANSITIONS).reduce((acc, [from, toArray]) => ({
        ...acc,
        [from]: toArray.map((to) => ({
          to,
          ...STATUS_METADATA[to],
        })),
      }), {});
    },
  },

  watch: {
    selectedVersionId() {
      if (this.selectedVersion) {
        this.localFilterVersion = { ...this.selectedVersion };
      } else {
        this.localFilterVersion = {
          code: '# There was an error loading this filter.',
          comment: '',
        };
      }
    },
  },

  mounted() {
    this.fetchFilterVersions().then(() => {
      if (this.filter.enabled_version) {
        this.selectedVersionId = this.filter.enabled_version.id;
      } else if (this.latestVersion) {
        this.selectedVersionId = this.latestVersion.id;
      }
    });
  },

  methods: {
    async uploadFilterVersion(file: File) {
      this.uploading = true;
      const reader = new FileReader();
      reader.readAsText(file);
      reader.onloadend = () => {
        if (reader.result) {
          this.localFilterVersion = {
            code: <string>reader.result,
            comment: '',
          };
          this.editing = true;
        }
        this.uploading = false;
      };
    },

    async editFilterVersion() {
      this.localFilterVersion = {
        code: this.selectedVersion ? this.selectedVersion.code : TEMPLATE_FIRST_FILTER_VERSION.code,
        comment: '',
      };
      this.editing = true;
    },

    async cancelEditFilterVersion() {
      this.localFilterVersion = {
        code: this.selectedVersion ? this.selectedVersion.code : TEMPLATE_FIRST_FILTER_VERSION.code,
        comment: '',
      };
      this.editing = false;
    },

    async submitFilterVersion() {
      let filterVersion : FilterVersion;
      this.submitting = true;
      try {
        ({ data: filterVersion } = await FilterService.addVersion(
          this.filter.id,
          {
            filter: { id: this.filter.id },
            ...this.localFilterVersion,
          },
        ));
      } catch (errors) {
        const { 0: error } = errors as Error[];
        this.errorMessage = `Error submitting new version: ${error.detail || error.title}`;
        this.showErrorMessage = true;
        return;
      } finally {
        this.submitting = false;
      }
      try {
        await this.fetchFilterVersions();
        const { data: filter } = await FilterService.get(this.filter.id, {});
        this.$emit('update:filter', filter);
        this.selectedVersionId = filterVersion.id;
      } catch (err) {
        this.warningMessage = 'Your filter was successfully updated but there was a problem refreshing the page.';
        this.showWarningMessage = true;
      } finally {
        this.editing = false;
      }
    },

    async fetchFilterVersions() {
      this.loading = true;
      try {
        const { data } = await FilterService.getVersions(
          this.filter.id,
          {
            sort: '-created_at',
            'page[limit]': 100,
          },
        );
        this.filterVersions = data;
        this.warningMessage = '';
        this.showWarningMessage = false;
        if (this.filterVersions.length === 0) {
          this.localFilterVersion = { ...TEMPLATE_FIRST_FILTER_VERSION };
          this.editing = true;
          this.warningMessage = 'This filter does not have submitted versions yet. Remember to submit one when you are ready.';
          this.showWarningMessage = true;
        }
      } catch (err) {
        this.errorMessage = 'There was an error fetching data. Please try again later.';
        this.showErrorMessage = true;
      } finally {
        this.loading = false;
      }
    },

    attemptTransitionTo(status: FILTER_VERSION_STATUS) {
      this.targetStatus = status;
      this.statusModalVisible = true;
    },

    async transitionFilterVersionTo(status: FILTER_VERSION_STATUS, payload: Pick<FilterVersion, 'feedback'>) {
      if (!this.selectedVersionId) return;

      this.transitioning = true;
      try {
        await FilterService.updateVersion(
          this.filter.id,
          this.selectedVersionId,
          { status, ...payload },
        );
        this.errorMessage = '';
        this.showErrorMessage = false;
      } catch (errors) {
        const { 0: error } = errors as Error[];
        this.errorMessage = `Error transitioning version: ${error.detail || error.title}`;
        this.showErrorMessage = true;
        this.transitioning = false;
        return;
      }
      try {
        await this.fetchFilterVersions();
        const { data: filter } = await FilterService.get(this.filter.id, {});
        this.$emit('update:filter', filter);
      } catch (err) {
        this.warningMessage = 'Filter version was successfully transitioned but there was a problem refreshing the page.';
        this.showWarningMessage = true;
      }
      this.transitioning = false;
    },
  },
});
</script>

<style>
#selected-version-tooltip {
  font-size: 1.3em;
  cursor: pointer;
}
.CodeMirror {
  height: 40em;
}
.alert {
  margin-bottom: 0;
  border-radius: 0;
}
.versions-viewer {
  overflow-x: hidden;
}
.version-info h2 {
  font-size: 1.2em;
  font-weight: bold;
}
.version-info .version-comment {
  color: #777777;
  margin: 0.5rem 0;
}
.editor-container {
  transition: max-width 150ms ease-in-out;
}
.sidebar-container {
  transition: margin-right 150ms ease-in-out;
}
@media (min-width: 576px) {
  .sidebar-container {
    margin-right: -25%;
  }
  .sidebar-container.visible {
    margin-right: 0;
  }
}
</style>
